<!--
/**
 * ----------------------------------------------------------------
 * @Copyright   : License MIT 2022
 *
 * @Author      : Alexandre Caillot
 * @WebSite     : https://www.shiros.fr
 *
 * @File        : IconLocation.vue
 * @Created_at  : 27/06/2022
 * @Update_at   : 27/06/2022
 * ----------------------------------------------------------------
 */
-->

<style type="text/css" src="./css/Icon.css" scoped/>

<script>
    export default {
        name: 'IconLocation',

        props: {
            design: {
                type: Object,
                default: () => {
                    return {};
                }
            }
        },

        data: () => {
            return {
                component: {
                    design: {
                        class: [],
                        style: {}
                    }
                }
            }
        },

        watch: {
            design: {
                handler: function (newDesign) {
                    this.prepareDesign(newDesign);
                },
                deep: true
            }
        },

        // Life Cycle : Created
        created() {
            this.init(this.design);
        },

        methods: {
            // ------------------------
            // Life cycle

            /**
             * Init component.
             *
             * @param design
             */
            init(design) {
                // ----------------
                // Process

                // Prepare information
                this.prepareDesign(design);
            },

            // ------------------------
            // Prepare methods

            /**
             * Prepare design.
             *
             * @param design
             */
            prepareDesign(design = {}) {
                // ----------------
                // Vars

                // Internal
                let internalDesign = {class: ['icon']};

                // External
                let externalDesign = {
                    class: design['class'] ?? [],
                    style: design['style'] ?? {},
                }

                // ----------------
                // Process

                // Component
                this.component.design.class = [...internalDesign.class, ...externalDesign.class];
                this.component.design.style = {...internalDesign.style, ...externalDesign.style};
            }
        }
    }
</script>

<template>
    <span :class="component.design.class" :style="component.design.style">
        <img src="@/assets/icons/location.png"/>
    </span>
</template>
